Attribute VB_Name = "Module1"
Option Explicit

Sub CopyAppointment()

    Dim objOL As Outlook.Application
    Dim objSelection As Outlook.Selection
    Dim objItem As Object
    Dim result As String
    Dim dt As String

    Set objOL = Outlook.Application
    dt = InputBox("Enter the new Date and Time . . . ")
    If Not IsDate(dt) Then
        MsgBox dt & " Is not a date."
        Exit Sub
    End If

    'Get the selected item
    Select Case TypeName(objOL.ActiveWindow)
        Case "Explorer"
            Set objSelection = objOL.ActiveExplorer.Selection
            If objSelection.Count > 0 Then
                Set objItem = objSelection.Item(1)
            Else
                result = MsgBox("No item selected. Please make a selection first.")
                Exit Sub
            End If
 
        Case "Inspector"
            Set objItem = objOL.ActiveInspector.CurrentItem
     
        Case Else
            result = MsgBox("Please make a selection in the Calendar or open an item first.")
            Exit Sub
    End Select

    Dim olAppt As Outlook.AppointmentItem
    Dim olApptCopy As Outlook.AppointmentItem
    Set olApptCopy = Outlook.CreateItem(olAppointmentItem)
 
    ' Start Copy
    If objItem.Class = olAppointment Then
        Set olAppt = objItem
 
        With olApptCopy
            .Start = CDate(dt)
            .End = CDate(dt)
            .Subject = olAppt.Subject
            .Location = olAppt.Location
            .Body = olAppt.Body
            .Categories = olAppt.Categories
            .AllDayEvent = olAppt.AllDayEvent
        End With
        ' olApptCopy.Save
         olApptCopy.Display
 
    'Selected item isn't an appointment item
    Else
        result = MsgBox("Please make a selection in the Calendar or open an item first.")
        Exit Sub
    End If

    Set objOL = Nothing
    Set objItem = Nothing
    Set olAppt = Nothing
    Set olApptCopy = Nothing

End Sub
